import java.awt.*;

public class DrawAreaPanel extends SuperPanel {

    // draw line and set start point 
    public void drawPic() {
        color %= 16;
        if (color < 1)   g.setColor(Color.black);
        else             g.setColor(frameColor[color]);
        
        if (pen == 1)    g.drawLine(px, py, tx, ty);

        color = 0;
	    if (tx < 0)   tx = 0;
        if (tx > 380) tx = 380;
        if (ty < 0)   ty = 0;
	    if (ty > 180) ty = 180;
        anx = anx % 360;

        // drawTurtle();
		px = tx;
        py = ty;
    }

    // handle !G command and compute data for drawpic
    public void handleString(String str) {
		if (! (str.equals("") || str.equals("#<void>") || (! islist(str)))) {
		    if (car(str).equals("!G")) {
		        g = getGraphics();
                cmd = car(cadr(str));
		        if (cmd.equals("CS"))   // Clear Graphics and GoHome
                    g.clearRect(0, 0, 500, 500);
                if (cmd.equals("HOME")) { // GoHome
                    px = 180;		py = 90;
		            tx = 180;		ty = 90;
		            anx = 270;		pen = 1;
                }
		        if (cmd.equals("FD"))  {  // Forward n step
		            color = 0;
		            step  = Integer.parseInt(cadr(cadr(str)));
		            tx = px + (int)(Math.cos(anx * ratio) * step);
		            ty = py + (int)(Math.sin(anx * ratio) * step);
		        }
		        if (cmd.equals("CFD")) {  // Forward n step
		            color = Integer.parseInt(caddr(cadr(str)));
		            step  = Integer.parseInt(cadr(cadr(str)));
            		tx = px + (int)(Math.cos(anx * ratio) * step);
            		ty = py + (int)(Math.sin(anx * ratio) * step);
		        }
		        if (cmd.equals("BK"))  {  // Backward n step
		            color = 0;
		            step  = Integer.parseInt(cadr(cadr(str)));
		            tx = px + (int)(Math.cos((anx+180) * ratio) * step);
		            ty = py + (int)(Math.sin((anx+180) * ratio) * step);
                }
		        if (cmd.equals("CBK")) {  // Backward n step
		            color = Integer.parseInt(caddr(cadr(str)));
		            step  = Integer.parseInt(cadr(cadr(str)));
		            tx = px + (int)(Math.cos((anx+180) * ratio) * step);
		            ty = py + (int)(Math.sin((anx+180) * ratio) * step);
		        }
		        if (cmd.equals("RT"))    // Right Turn n degree
		            anx += Integer.parseInt(cadr(cadr(str)));    
		        if (cmd.equals("LT"))    // Left Turn n degree
		            anx -= Integer.parseInt(cadr(cadr(str)));    
		        if (cmd.equals("PD"))    // Pen Down
		            pen = 1;
		        if (cmd.equals("PU"))    // Pen Up
		            pen = 0;

		        drawPic();
		    }
    	}
    }

    //constructor
	public DrawAreaPanel() {
		super();
	}
	
	// draw turtle
	/*
	public void drawTurtle() {
	    g = getGraphics();
	    
        p1x = px + Math.cos(anx * ratio) * 10;
        p1y = py + Math.sin(anx * ratio) * 10;
        p2x = px + Math.cos((anx + 150) * ratio) * 10;
        p2y = py + Math.sin((anx + 150) * ratio) * 10;
        p3x = px + Math.cos((anx + 210) * ratio) * 10;
        p3y = py + Math.sin((anx + 210) * ratio) * 10;

        g.setXORMode(Color.white);
        g.setColor(Color.black);
        g.drawLine((int)p1x, (int)p1y, (int)p2x, (int)p2y);
        g.drawLine((int)p2x, (int)p2y, (int)p3x, (int)p3y);
        g.drawLine((int)p3x, (int)p3y, (int)p1x, (int)p1y);
        g.setPaintMode();
	}
	*/
	
    int      px = 180,  py = 90,   // start point
             tx = 180,  ty = 90,   // end point 
             anx = 270, pen = 1,   // angle , pen stat
             step = 0, color = 0;  // distance for move , color stat
    // double   p1x, p1y, p2x, p2y, p3x, p3y;  // turtle's data
    String   cmd;                
    double   ratio=3.14159265358979323846/180;
    Graphics g;
}
