(define (next-leaf-generator obj eot)
  (letrec ((return #f)
	   (cont (lambda (x)
		   (re-cur obj)
		   (set! cont (lambda (x) (return eot)))
		   (cont #f)))
	   (re-cur (lambda (obj)
		      (if (pair? obj)
			  (for-each re-cur obj)
			  (call-with-current-continuation
			   (lambda (c)
			     (set! cont c)
			     (return obj)))))))
    (lambda () (call-with-current-continuation
		(lambda (ret) (set! return ret) (cont #f))))))

(define (leaf-eq? x y)
  (let* ((eot (list 'eot))
	 (xf (next-leaf-generator x eot))
	 (yf (next-leaf-generator y eot)))
    (letrec ((loop (lambda (x y)
		     (cond ((not (eq? x y)) #f)
			   ((eq? eot x) #t)
			   (else (loop (xf) (yf)))))))
      (loop (xf) (yf)))))

(display (list  '!H
"This example demonstrace call/cc:
 1. Enter (leaf-eq? '(a (b (c))) '((a) b c))
    in the Instruction area followed by 
    pressing Submit.
 2. Press RUN to see a big environment tree.
 You can also submit
     (leaf-eq? '(a (b (c))) '((a) b c d))
 and Run it."))
(display (list '!U "
(define (next-leaf-generator obj eot)
  (letrec ((return #f)
	   (cont (lambda (x)
		   (re-cur obj)
		   (set! cont (lambda (x) (return eot)))
		   (cont #f)))
	   (re-cur (lambda (obj)
		      (if (pair? obj)
			  (for-each re-cur obj)
			  (call-with-current-continuation
			   (lambda (c)
			     (set! cont c)
			     (return obj)))))))
    (lambda () (call-with-current-continuation
		(lambda (ret) (set! return ret) (cont #f))))))
(define (leaf-eq? x y)
  (let* ((eot (list 'eot))
	 (xf (next-leaf-generator x eot))
	 (yf (next-leaf-generator y eot)))
    (letrec ((loop (lambda (x y)
		     (cond ((not (eq? x y)) #f)
			   ((eq? eot x) #t)
			   (else (loop (xf) (yf)))))))
      (loop (xf) (yf)))))
"))

;(leaf-eq? '(a (b (c))) '((a) b c))
;(leaf-eq? '(a (b (c))) '((a) b c d))


