;;; Copyright (C) 1995 Sho-Huan Simon Tung
;;; See ./VES2/COPYING for details

(define do-load
  (lambda (command)
    (pretty-print (list '!Z 0 0))
    (let ([inp (open-input-file (cadr command))])
      (dynamic-wind
       (lambda () #f)
       (lambda ()
	 (let f ([command (expand (read inp))])
	   (if (eof-object? command)
	       'ignore
	       (begin
		 (set! steps -1)
		 (set-new&set)
		 (set! call-cc-called #f)
		 (set! cont-called #f)
				   ;;; havn't test catch of call/cc
		 ((rec loop
		       (lambda (crnt-exp-env)
			 (if (and (exp-env? crnt-exp-env)
				  (value? (exp-env-env crnt-exp-env))
				  (not (eq? 'to-receive
					    (exp-env-env crnt-exp-env))))
			     (begin
			       (set! current-exp-env crnt-exp-env)
			       (my-pretty (output-mgr  crnt-exp-env)))
			     (if (= 0 steps)
				 (if call-cc-called
				     (begin
				       (set! call-cc-called #f)
				       (let* ([c-obj (make-exp-env
						      `(!K ,crnt-exp-env)
						      'cont-obj
						      (tail-enable?) 0)]
					      [c-app-obj
					       `(,call-cc-arg ,c-obj)])
					 (set! current-exp-env
					       (subst c-app-obj
						      cont-val crnt-exp-env)))
				       (set! steps -1)
				       (set-new&set)
				       (set! call/cc-called #f)
				       (set! cont-called #f)
				       (loop (meaning current-exp-env)))
				     (if cont-called
					 (begin
					   (set! cont-called #f)
					   (set! steps -1)
					   (set-new&set)
					   (set! call/cc-called #f)
					   (set! current-exp-env new-control)
					   (loop (meaning current-exp-env)))
					 (begin
					   (set! current-exp-env crnt-exp-env)
					   (printf "Load stoped.~%")
					   current-exp-env)))
				 (loop (meaning crnt-exp-env))))))
		  (make-exp-env command (list (list 0))
				#f 0))
		 (f (expand (read inp)))))))
       (lambda () (close-input-port inp))))
    (if (value? current-exp-env)
	(make-exp-env
	 (printf "File: ~s loaded.~%" (cadr command))
	 'after-set! 
	 #f 0)
	current-exp-env)))

(define gc-bound (- (get-num-of-frames) 7))

(define meaning
  (lambda (exp-env)       ; exp-env ::= #exp-env | (#exp-env ...)
    (if (> (get-max-frame-num) gc-bound)
	(begin
	  (printf "WARNING: Frame number about to reach ~s - click Recycle.~%"
		  (get-num-of-frames))
	  (set! steps 0)
	  (set! gc-bound (if (< gc-bound (get-num-of-frames))
			     (+ gc-bound 1)
			     gc-bound)))
	(if (< (get-max-frame-num) (- (get-num-of-frames) 7))
	    (set! gc-bound (- (get-num-of-frames) 7))))
    (if (= 0 steps)
	exp-env
	(if (exp-env? exp-env)
	    (let ([exp (exp-env-exp exp-env)]
		  [env (exp-env-env exp-env)]
		  [tail (exp-env-tail exp-env)]
		  [fno (exp-env-fno exp-env)])  ; env | after-lookup
	      (if (value? env)
		  exp-env
		  (cond
		    [(symbol? exp)
		     (let ([v (lookup exp env)])
		       (if (and (pair? v)
				(or (eq? '*closure* (car v))
				    (eq? '!K (car v))))
			   (begin
			     (set! steps (- steps 1))
			     (if (memq exp run-till) (set! steps 0))
			     (if (eq? '!K (car v))
				 (make-exp-env v 'cont-obj tail fno)
				 (make-exp-env v 'after-lookup tail fno)))
			   (begin
			     (if micro (set! steps  (- steps 1)))
			     (if (memq exp run-till) (set! steps 0))
			     (make-exp-env v 'after-lookup #f 0))))]
		    [(pair? exp)
		     (case (car exp)
		       [(letrec) (meaning (make-exp-env
					    (expand-letrec exp) env tail fno))]
		       [(load) (do-load exp)]
		       [(define)
			(set! steps (- steps 1))
			(set-new&set)
			(let ([pair (exist-in-top-level? (cadr exp))])
			  (if (not pair)
			      (begin
				(add-top-level (cadr exp) '|-|)
				(if display-env?
				    (printf (format "(!S (0 ~s ~c<void>))~%"
					      (cadr exp)
					      #\# ))))))
			(meaning
			  (make-exp-env
			    `(set! ,(cadr exp)
			       ,(caddr exp))
			    (list (list 0)) #f 0))]
		       [(|#primitive|)
			(let ([v (lookup (cadr exp) env)])
			  (if micro (set! steps (- steps 1)))
			  (make-exp-env v 'after-lookup #f 0))]
		       [(quote)
			(if micro (set! steps  (- steps 1)))
			(if (memq 'quote-exp run-till) (set! steps 0))
			(make-exp-env (cadr exp) 'simple-value #f 0)]
		       [(lambda)
			(set! steps  (- steps 1))
			(if (memq 'lambda-exp run-till) (set! steps 0))
			(let ([body (cddr exp)])
			  (if (= 1 (length body))
			      (make-exp-env (list '*closure* exp env)
				'after-lambda tail fno)
			      (make-exp-env
				(list '*closure* `(lambda ,(cadr exp)
						    ,(cons 'begin body)) env)
				'after-lambda tail fno)))]
		       [(if) (let ([test-pt (make-exp-env (cadr exp) env #f 0)]
				   [then-pt (make-exp-env (caddr exp) env tail
					      fno)]
				   [else-pt (make-exp-env (cadddr exp) env tail
					      fno)])
			       (set! steps  (- steps 1))
			       (if (memq 'if-exp run-till) (set! steps 0))
			       (meaning `(if ,test-pt ,then-pt ,else-pt)))]
		       [(COND)
			(set! steps (- steps 1))
			(let ([items ((rec loop
					(lambda (l)
					  (if (null? (cdr l))
					      (list
					       (list
						(make-exp-env (caar l) env
						      tail fno)
						(make-exp-env (cadar l) env
						      tail fno)))
					      (cons
					       (list
						(make-exp-env (caar l)
						      env #f 0)
						(make-exp-env (cadar l)
						      env #f 0))
						    (loop (cdr l))))))
				      (cdr exp))])
			  (meaning (cons 'COND items)))]
		       [(set!)
			(let ([val-pt (make-exp-env (caddr exp) env #f 0)])
			  (if micro (set! steps (- steps 1)))
			  (if (memq 'set!-exp run-till) (set! steps 0))
			  (meaning `(set! ,(make-exp-env (cadr exp) env #f 0)
				      ,val-pt)))]
		       [(CFD CBK)
			(meaning `(,(car exp)
				   ,(make-exp-env (cadr exp) env #f 0)
				   ,(make-exp-env (caar env) 'simple-value
							  #f 0)))]
		       [(begin)
			(set! steps (- steps 1))
			(let ([items ((rec loop
					(lambda (l)
					  (if (null? (cdr l))
					      (list (make-exp-env (car l) env
						      tail fno))
					      (cons (make-exp-env (car l)
						      env #f 0) 
						    (loop (cdr l))))))
				      (cdr exp))])
			  (meaning (cons 'begin items)))]
		       [else
			 (let ([exps-pt (begin
					  (if micro (set! steps (- steps 1)))
					  (cons
					    (rllr-lambda-pos exp env tail fno)
					    (rllr-map 
					      (lambda (x)
						(meaning
						  (make-exp-env
						    x env #f 0)))
					      (cdr exp))))])
			   (meaning exps-pt))])]
		    [else
		      (if micro (set! steps (- steps 1)))
		      (make-exp-env exp 'simple-value tail fno)])))
	    (if (pair? exp-env)
		(case (car exp-env)
		  [(if) (let ([tst-rsl (cadr exp-env)])
			  (if (exp-env? tst-rsl)
			      (let ([tst-rsl-exp (exp-env-exp tst-rsl)]
				    [tst-rsl-env (exp-env-env tst-rsl)])
				(if (value? tst-rsl-env)
				    (begin
				      (set! steps (- steps 1))
				      (if tst-rsl-exp
					  (meaning (caddr exp-env))
					  (meaning (cadddr exp-env))))
				    (meaning
				      `(if ,(meaning tst-rsl) ,(caddr exp-env)
					 ,(cadddr exp-env)))))
			      (meaning
				`(if ,(meaning tst-rsl) ,(caddr exp-env)
				   ,(cadddr exp-env)))))]
		  [(CFD CBK)
		   (let ([val-pt (cadr exp-env)])
	             (if (exp-env? val-pt)
		  	 (let ([val-pt-exp (exp-env-exp val-pt)]
			       [val-pt-env (exp-env-env val-pt)])
		 	   (if (value? val-pt-env)
			       (begin
			 	 (set! steps (- steps 1))
				 (make-exp-env
				   (begin
				     (display
				       `(!G (,(car exp-env)
				  	     ,val-pt-exp 
 					     ,(exp-env-exp (caddr exp-env)))))
				     (newline))
				     'after-set!
				     #f 0))
				(meaning
				  `(,(car exp-env)
				    ,(meaning val-pt)
				    ,(caddr exp-env)))))
 			  (meaning
			    `(,(car exp-env)
			      ,(meaning val-pt)
                              ,(caddr exp-env)))))]
		  [(set!) (let ([val-pt (caddr exp-env)])
			    (if (exp-env? val-pt)
				(let ([val-pt-exp (exp-env-exp val-pt)]
				      [val-pt-env (exp-env-env val-pt)])
				  (if (value? val-pt-env)
				      (begin
					(set! steps (- steps 1))
					(make-exp-env
					  (assign (exp-env-exp (cadr exp-env))
					    val-pt-exp
					    (exp-env-env (cadr exp-env)))
					  'after-set!
					  #f 0))
				      (meaning
					`(set! ,(cadr exp-env)
					   ,(meaning val-pt)))))
				(meaning
				  `(set! ,(cadr exp-env) ,(meaning val-pt)))))]
		  [(begin)
		   (let ([rsl
			   ((rec loop
			      (lambda (rest)
				(if (null? rest)
				    '()
				    (let* ([first (car rest)])
				      (if (exp-env? first)
					  (let 
					    ([first-exp
					       (exp-env-exp first)]
					     [first-env
					       (exp-env-env first)])
					    (if (value? first-env)
						(loop (cdr rest))
						(cons (meaning first)
						      (cdr rest))))
					  (cons (meaning first)
						(cdr rest)))))))
			    (cdr exp-env))])
		     (let ([last (car (last-pair rsl))])
		       (if (exp-env? last)
			   (let ([last-exp (exp-env-exp last)]
				 [last-env (exp-env-env last)])
			     (if (and (= 1 (length rsl))
				      (value? last-env)
				      (or (> steps 0) (< steps 0)))
				 (begin
				   (if micro (set! steps (- steps 1)))
				   last)
				 (if (= 1 (length rsl))
				     (meaning last)
				     (meaning (cons 'begin rsl)))))
			   (if (= 1 (length rsl))
			       (meaning last)
			       (meaning (cons 'begin rsl))))))]
		  [(COND)
		   (if (= 1 (length (cdr exp-env)))
		       (begin
			 (set! steps (- steps 1))		   
			 (meaning (cadr (cadr exp-env))))
		       (let ([1st-tst (caadr exp-env)])
			  (if (exp-env? 1st-tst)
			      (let ([1st-tst-exp (exp-env-exp 1st-tst)]
				    [1st-tst-env (exp-env-env 1st-tst)])
				(if (value? 1st-tst-env)
				    (begin
				      (set! steps (- steps 1))		   
				      (if 1st-tst-exp
					  (meaning (cadr (cadr exp-env)))
					  (meaning
					    (cons 'COND
						  (cddr exp-env)))))
				    (meaning
				      (cons 'COND
					    (cons
					     `(,(meaning 1st-tst)
					       ,(cadr (cadr exp-env)))
					      (cddr exp-env))))))
			      (meaning
			       (cons 'COND
				     (cons
				      `(,(meaning 1st-tst)
					,(cadr (cadr exp-env)))
				      (cddr exp-env)))))))]
		  [else
		    (let ([exps-pt (rllr-map meaning exp-env)])
;		      (if (memq 'app-exp run-till) (set! steps 0))
		      (if (and (or (> steps 0) (< steps 0))
			       (andmap (lambda (item)
					 (and (exp-env? item)
					      (value? (exp-env-env item))))
				 exps-pt))
			  (begin
			    (set! steps (- steps 1))
			    (let ([fun-pt (exp-env-exp (car exps-pt))]
				  [tail (exp-env-tail (car exps-pt))]
				  [fno (exp-env-fno (car exps-pt))]
				  [args-pt (map exp-env-exp (cdr exps-pt))])
			      (if (procedure? fun-pt)
				  (let ([r (apply fun-pt args-pt)])
				    (if (and (list? r)
					     (not (null? r))
					     (ormap exp-env? r))
					(meaning r)
					(if (equal? cont-val r)
					    r
					    (if (and (pair? r)
						     (eq? '*this*is*for*each*
							  (car r)))
						(meaning (cons 'begin
							       (cdr r)))
						(make-exp-env
						  r
						  'after-apply #f 0)))))
				  (if (closure? fun-pt)
				      (let* ([lambda-exp (cadr fun-pt)]
					     [nw-env (new-env
						       (formals lambda-exp)
						       args-pt
						       (env-pt fun-pt)
						       tail fno)]
					     [new-rib (car nw-env)]
					     [body-exp (body lambda-exp)])
					(meaning
					  (make-exp-env
					    (car body-exp)
					    nw-env
					    tail
					    (car new-rib)
					    )))
				      (if (continuation? fun-pt)
					  (let ([cont (cadr fun-pt)])
					    (set! new-control
					      (substq (cadr exps-pt)
						cont-val cont))
					    (set! steps 0)
					    (set! cont-called #t))
					  (error 'meaning "Can not apply ~s"
					    exps-pt))))))
			  (meaning exps-pt)))])
		(error 'meaning "Wrong argument ~s" exp-env))))))

(define expand-letrec
  (lambda (e)
    (let ([vars ((rec loop
		   (lambda (l)
		     (if (null? l)
			 '()
			 (cons (caar l) (loop (cdr l)))))) (cadr e))]
	  [sets ((rec loop
		   (lambda (l)
		     (if (null? l)
			 '()
			 (cons (list 'set! (caar l) (cadar l))
			       (loop (cdr l)))))) (cadr e))]
	  [es (cddr e)]
	  [fs ((rec loop
		 (lambda (l)
		   (if (null? l)
		       '()
		       (cons #f (loop (cdr l)))))) (cadr e))])
    `((lambda ,vars ,@sets ,@es) ,@fs))))
